#include <bits/stdc++.h>

using namespace std;

vector<int> v1;
int main(){
    int n;
    cin>>n;
    bool next=true;
    vector<int> v2 (n,'A');
    for(int i=1;i<n;i++){
        int u,v;
        char c;
        cin>>u>>v>>c;
        if(abs(u-v)!=1){
            next=false;
        }
        //v1.push_back(make_pair(u,v));
        v2[min(u,v)]=c;
    }
    if(next){
        int lastappS=0,lastappO=0,lastappI=0;
        int s=0;
        for(int i=1;i<n;i++){
            if(v2[i]=='S'){
                lastappS=i;
            }
            if(v2[i]=='I'){
                lastappI=i;
            }
            if(v2[i]=='O'){
                lastappO=i;
            }
            s=s+min(min(lastappI,lastappO),lastappS);
        }
        cout<<s;
    }
    return 0;
}